private import common;
private import obj;

class ObjMgr(O) : Obj {
    O[] objs;

    this(char[] name) {
        name_ = name;
    }

    int objNum() {
        return objs.length;
    }

    override void move() {
        O[] nobjs;
        //Log.dbg(name_ ~ tostr(objNum()));

        foreach (O p; objs) {
            if (p.alive()) {
                p.move();
                nobjs ~= p;
            }
            else {
                delete p;
            }
        }
        objs = nobjs;
    }

    override void draw() {
        foreach (O p; objs) {
            p.draw();
        }
    }

    void interact() {
        foreach (int i, O p; objs) {
            for (int j = i+1; j < objs.length; j++) {
                p.interact(objs[j]);
            }
        }
    }

    void add(O p) {
        objs ~= p;
    }

private:
    char[] name_;
}

