static const char[] MAJAR_VERSION="0";
static const char[] MINOR_VERSION="3";
static const char[] PATCH_VERSION="0";

static const char[] REPLAY_VERSION=MAJAR_VERSION~"."~MINOR_VERSION;

private import common;

private import std.conv;
private import std.string;

static int versionNum;

void initVersion(int major, int minor, int patch) {
    versionNum = major*100 + minor*10 + patch;
}

void initVersion(char[] versionStr) {
    char[][] ver = versionStr.split(`.`);
    if (ver.length == 2) {
        initVersion(toInt(ver[0]), toInt(ver[1]), 0);
    }
    else if (ver.length == 3) {
        initVersion(toInt(ver[0]), toInt(ver[1]), toInt(ver[2]));
    }
    else {
        Log.warn(`corrupt replay version!, trying current version...`);
        initVersion();
    }
}

void initVersion() {
    initVersion(
        toInt(MAJAR_VERSION), toInt(MINOR_VERSION), toInt(PATCH_VERSION));
}

