private import game;
private import scene;
private import log;

class SceneGame : Scene {
public:
    this() {
        Log.info("scene game");
        game_ = new Game();
    }

    bit isEnd() {
        return game_.isEnd();
    }

    Scene getNext() {
        if (game_.isEnd()) {
            return new SceneResult(game_);
        }
        else {
            return new SceneSelect();
        }
    }

    void run() {
        game_.run();
    }

    int objectNum() {
        return game_.objectNum();
    }

private:
    Game game_;
};

