private import http;
private import sino;
private import common;

private import SDL;

private import std.thread;

class HttpThread : Thread {
    this(char[] q) {
        q_ = q;
        startTicks_ = SDL_GetTicks();
    }

    override int run() {
        try {
            char[] host = Sino.rc.get(`scoreServer`);
            int port = Sino.rc.getInt(`scorePort`);
            char[] dir = Sino.rc.get(`scorePath`);

            Http h = new Http10(host, port);
            res_ = h.post(dir ~ `/scoreregist.cgi`, q_);

            isEnd_ = true;
        }
        catch (Object o) {
            Log.warn("cannot connect score server: " ~ o.toString());
            isError_ = true;
        }

        return 0;
    }

    bool isEnd() {
        return isEnd_;
    }

    bool isError() {
        return isError_;
    }

    bool isTimeout() {
        return startTicks_+15000 < SDL_GetTicks();
    }

    HttpResponse response() {
        return res_;
    }

private:
    char[] q_;
    bool isEnd_;
    bool isError_;
    HttpResponse res_;
    int startTicks_;
}

HttpThread httpThread;
