private import objmgr;
private import drawobjs;
private import info_draw;
private import viewports;

abstract class Scene {
public:
    bit isEnd();
    Scene getNext();
    void run();
    int objectNum() { return 0; }
    bool isEndIsQuit() { return false; }

protected:
    static void init() {
        draws_ = new ObjMgr!(DrawObj)("draw");
        draws_.add(new SysViewport());
        draws_.add(new PsynoDraw());
    }

    static ObjMgr!(DrawObj) draws_;

};

import scene_select;
import scene_game;
import scene_result;
